// Copyright 2019 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Code generated by protoc-gen-go-grpc. DO NOT EDIT.
// versions:
// - protoc-gen-go-grpc v1.3.0
// - protoc             v4.25.3
// source: pubsub.proto

package pubsub_bench

import (
	context "context"

	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

const (
	PubsubBenchWrapper_Recv_FullMethodName = "/pubsub_bench.PubsubBenchWrapper/Recv"
)

// PubsubBenchWrapperClient is the client API for PubsubBenchWrapper service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type PubsubBenchWrapperClient interface {
	// Recv represents opening a streaming pull stream to receive messages on.
	Recv(ctx context.Context, in *PubsubRecv, opts ...grpc.CallOption) (*EmptyResponse, error)
}

type pubsubBenchWrapperClient struct {
	cc grpc.ClientConnInterface
}

func NewPubsubBenchWrapperClient(cc grpc.ClientConnInterface) PubsubBenchWrapperClient {
	return &pubsubBenchWrapperClient{cc}
}

func (c *pubsubBenchWrapperClient) Recv(ctx context.Context, in *PubsubRecv, opts ...grpc.CallOption) (*EmptyResponse, error) {
	out := new(EmptyResponse)
	err := c.cc.Invoke(ctx, PubsubBenchWrapper_Recv_FullMethodName, in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// PubsubBenchWrapperServer is the server API for PubsubBenchWrapper service.
// All implementations must embed UnimplementedPubsubBenchWrapperServer
// for forward compatibility
type PubsubBenchWrapperServer interface {
	// Recv represents opening a streaming pull stream to receive messages on.
	Recv(context.Context, *PubsubRecv) (*EmptyResponse, error)
	mustEmbedUnimplementedPubsubBenchWrapperServer()
}

// UnimplementedPubsubBenchWrapperServer must be embedded to have forward compatible implementations.
type UnimplementedPubsubBenchWrapperServer struct {
}

func (UnimplementedPubsubBenchWrapperServer) Recv(context.Context, *PubsubRecv) (*EmptyResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Recv not implemented")
}
func (UnimplementedPubsubBenchWrapperServer) mustEmbedUnimplementedPubsubBenchWrapperServer() {}

// UnsafePubsubBenchWrapperServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to PubsubBenchWrapperServer will
// result in compilation errors.
type UnsafePubsubBenchWrapperServer interface {
	mustEmbedUnimplementedPubsubBenchWrapperServer()
}

func RegisterPubsubBenchWrapperServer(s grpc.ServiceRegistrar, srv PubsubBenchWrapperServer) {
	s.RegisterService(&PubsubBenchWrapper_ServiceDesc, srv)
}

func _PubsubBenchWrapper_Recv_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(PubsubRecv)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(PubsubBenchWrapperServer).Recv(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: PubsubBenchWrapper_Recv_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(PubsubBenchWrapperServer).Recv(ctx, req.(*PubsubRecv))
	}
	return interceptor(ctx, in, info, handler)
}

// PubsubBenchWrapper_ServiceDesc is the grpc.ServiceDesc for PubsubBenchWrapper service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var PubsubBenchWrapper_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "pubsub_bench.PubsubBenchWrapper",
	HandlerType: (*PubsubBenchWrapperServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "Recv",
			Handler:    _PubsubBenchWrapper_Recv_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "pubsub.proto",
}
